pipeline {
    agent any
    tools {
        oc 'oc'
        maven 'maven'
    }
    environment {
        CLUSTER_NAME = 'ocp_ducpham'
        DEV_ENV      = 'komaichi257-dev'
        STAGE_ENV    = 'komaichi257-stage'
        imagestream_name = 'testimagestream'
        bc_name = 'testbc'
        dc_name = 'testdc'
    }

    stages {
        stage('Build App') {
            steps {
                sh 'mvn -B -DskipTests clean package'
            }
        }
        stage('SonarQube Analysis') {
            steps{
                withSonarQubeEnv(installationName: 'sonarqube') {
                sh 'mvn sonar:sonar -D sonar.projectKey=sonartest -D sonar.language=java -D sonar.host.url=http://52.220.217.92:9000/ '
                }
            }
        }
        stage('Create Require Configuration for SIT Environment') {
            steps {
                script {
                    openshift.withCluster("${CLUSTER_NAME}") {
                        openshift.withProject("${DEV_ENV}") {
                            if (!openshift.selector('imagestreams', '${imagestream_name}').exists())
                                openshift.create("-f '${imagestream_name}'.yaml").object()
                            if (!openshift.selector('bc', '${bc_name}').exists())
                                openshift.create("-f '${bc_name}'.yaml").object()
                            if (!openshift.selector('dc', '${dc_name}').exists())
                                openshift.create("-f '${dc_name}'.yaml").object()
                        }
                    }
                }
            }
        }
        stage('Build Image') {
            steps {
                script {
                    sh 'ls'
                    openshift.withCluster("${CLUSTER_NAME}") {
                        openshift.withProject("${DEV_ENV}") {
                            openshift.selector('bc', "'${bc_name}'").startBuild('--from-file=target/microservice-app-1.0.0-SNAPSHOT.jar','--follow', '--wait=true')
                        }
                    }
                }
            }
        }
        stage('Deploy DEV') {
            steps {
                script {
                    openshift.withCluster("${CLUSTER_NAME}") {
                        openshift.withProject("${DEV_ENV}") {
                            openshift.selector('dc', "'${dc_name}'").rollout().latest()
                        }
                    }
                }
            }
        }
        stage('Promote to UAT?') {
      steps {
        timeout(time:15, unit:'MINUTES') {
            input message: "Promote to UAT?", ok: "Promote"
        }

        script {
          openshift.withCluster("${env.CLUSTER_NAME}") {
          openshift.withProject("${env.DEV_ENV}") {
              openshift.tag("${env.DEV_ENV}/${imagestream_name}:latest", "${STAGE_ENV}/${imagestream_name}:stage")
            }
          }
        }
      }
    }
    stage('Create Require Configuration for UAT Environment') {
            steps {
                script {
                    openshift.withCluster("${CLUSTER_NAME}") {
                        openshift.withProject("${STAGE_ENV}") {
                            if (!openshift.selector('imagestreams', '${imagestream_name}').exists())
                                openshift.create("-f '${imagestream_name}'.yaml").object()
                            if (!openshift.selector('bc', '${bc_name}').exists())
                                openshift.create("-f '${bc_name}'.yaml").object()
                            if (!openshift.selector('dc', '${dc_name}').exists())
                                openshift.create("-f '${dc_name}'.yaml").object()
                        }
                    }
                }
            }
        }
    stage('Deploy STAGE') {
      steps {
        script {
          openshift.withCluster("${env.CLUSTER_NAME}") {
            openshift.withProject("${STAGE_ENV}") {
              openshift.selector("dc", "${dc_name}").rollout().latest();
            }
          }
        }
      }
    }
  }
}
